require 'spec_helper'

describe 'store_json' do
  context 'supported operating systems' do
    on_supported_os.each do |os, facts|
      context "on #{os}" do
        let(:facts) do
          facts
        end

        context "store_json class without any parameters" do
          it { is_expected.to compile.with_all_deps }

          it { is_expected.to contain_class('store_json::params') }
          it { is_expected.to contain_class('store_json::install').that_comes_before('store_json::config') }
          it { is_expected.to contain_class('store_json::config') }
          it { is_expected.to contain_class('store_json::service').that_subscribes_to('store_json::config') }

          it { is_expected.to contain_service('store_json') }
          it { is_expected.to contain_package('store_json').with_ensure('present') }
        end
      end
    end
  end

  context 'unsupported operating system' do
    describe 'store_json class without any parameters on Solaris/Nexenta' do
      let(:facts) do
        {
          :osfamily        => 'Solaris',
          :operatingsystem => 'Nexenta',
        }
      end

      it { expect { is_expected.to contain_package('store_json') }.to raise_error(Puppet::Error, /Nexenta not supported/) }
    end
  end
end
